function module (config, errback) {
   "use strict";

   var exports = {},
       _ = require('underscore'),
       async = require('async'),
       timer,
       log = config.log,
       exec = require('child_process').exec,
       writeFile = require('fs').writeFile,
       readFile = require('fs').readFile,
       rename = require('fs').rename,
       statusData = {};

   function status (callback) {
      callback(null, statusData);
   }

   function copyFiles(done) {
      exec('cp -r ' + config.modules.web.from + " " + config.paths.output + "/", 
         function (err, stdout, stderr) {
            if (err) return log.error(err);
            if (stderr) return log.error(stderr);

            // make config
            readFile(
               config.paths.output + "/config.sample.php",
               function (err, data) {
                  if (err) return log.error(err);

                  var out = _.template(String(data), config);

                  writeFile(
                     config.paths.temp + "/config.php",
                     out,
                     function (err) {
                        if (err) return log.error(err);

                        rename(
                           config.paths.temp + "/config.php",
                           config.paths.output + "/config.php",
                           function (err) {
                              if (err) return log.error(err);

                              log.info('web: created php config');
                           }
                        )
                     }
                  );
               }
            );
         }
      );
   }

   function start () {
      log.info('copy: copying web stuff');
      copyFiles();
   }

   function shutdown (done) {
      done();
   }

   exports.start = start;
   exports.shutdown = shutdown;
   exports.status = status;

   return exports;
}

exports.module = module;
